<?php
defined('UPDATEALBUM_PATH') or die('Hacking attempt!');

global $conf, $template, $page;


// +-----------------------------------------------------------------------+
// | Basic checks                                                          |
// +-----------------------------------------------------------------------+

check_status(ACCESS_ADMINISTRATOR);

check_input_parameter('cat_id', $_GET, false, PATTERN_ID);
$cat_id = $_GET['cat_id'];

$admin_album_base_url = get_root_url().'admin.php?page=album-'.$cat_id;
$self_url = SMART_ADMIN.'-album&amp;cat_id='.$cat_id;
$base_url = get_root_url().'admin.php?page=';

$query = '
SELECT *
  FROM '.CATEGORIES_TABLE.'
  WHERE id = '.$cat_id.'
;';
$category = pwg_db_fetch_assoc(pwg_query($query));

if (!isset($category['id']))
{
  die("unknown album");
}

// +-----------------------------------------------------------------------+
// | Tab                                                              |
// +-----------------------------------------------------------------------+

include_once(PHPWG_ROOT_PATH.'admin/include/tabsheet.class.php');
$tabsheet = new tabsheet();
$tabsheet->set_id('album');
$tabsheet->select('updatealbum');
$tabsheet->assign();

// save config
if (isset($_POST['submit']))
{
	$conf['updatealbum']['update'] = isset($_POST['updateFlag']);
	$conf['updatealbum']['create'] = isset($_POST['createFlag']);
	$conf['updatealbum']['verbose'] = isset($_POST['verboseFlag']);

	conf_update_param('updatealbum', $conf['updatealbum']);
 }
// send config to template
$template->assign(array(
  'updatealbum' => $conf['updatealbum'],
  ));

if (isset($_FILES['imagesfiles']))
{
  include_once(PHPWG_ROOT_PATH.'admin/include/functions_upload.inc.php');
  


	if ($_FILES['imagesfiles']['error'][0] == UPLOAD_ERR_NO_FILE) {
//		$page['infos'][] = l10n('No file selected');
	}
	else {
		// number of files to be uploaded
		$nbFiles = count($_FILES['imagesfiles']['name']);
		$page['infos'][] = l10n('Selected Files').': '.$nbFiles;
		if ($conf['updatealbum']['verbose']) {
			$query = '
			SELECT ic.name
			  FROM '.CATEGORIES_TABLE.' AS ic
			  WHERE ic.id = '.$cat_id.'
			;';
			$parent_cat = pwg_db_fetch_assoc(pwg_query($query));
			$page['infos'][] = l10n('Selected Album').': '.$parent_cat['name'].' -> '.$cat_id;
		}
		$nbUpdated = 0;
		$nbCreated = 0;
		$nbErrors = 0;

		for($i=0; $i<$nbFiles; $i++) {
			if ($_FILES['imagesfiles']['error'][$i] !== UPLOAD_ERR_OK) {
				$error_message = file_upload_error_message($_FILES['imagesfiles']['error'][$i]);
				$page['infos'][] = $_FILES['imagesfiles']['name'][$i].' : '.l10n('Error').' -> '.$error_message;
				$nbErrors++;
			}
			elseif (!in_array(strtolower(get_extension($_FILES['imagesfiles']['name'][$i])), array('jpg', 'jpeg', 'png', 'gif')))  {
				$page['infos'][] = $_FILES['imagesfiles']['name'][$i].' : '.l10n('Error').' -> '.l10n('Unsupported file extension');
				$nbErrors++;
			}
			else {
			// identify the corresponding image in the album			
				$query = '
				SELECT i.id, i.file
				  FROM '.IMAGES_TABLE.' AS i
					JOIN '.IMAGE_CATEGORY_TABLE.' AS ic ON image_id = i.id
				  WHERE ic.category_id = '.$cat_id.' AND i.file = \''.$_FILES['imagesfiles']['name'][$i].'\'
				;';

				$image = pwg_db_fetch_assoc(pwg_query($query));
				if (!empty($image)) { // if image found 
					if ($conf['updatealbum']['update']) { // if update flag then update it
						add_uploaded_file(
							$_FILES['imagesfiles']['tmp_name'][$i],
							$_FILES['imagesfiles']['name'][$i],
							null,
							null,
							$image['id']
							);
						if ($conf['updatealbum']['verbose']) $page['infos'][] = $_FILES['imagesfiles']['name'][$i].' : '.l10n('Updated image').' -> '.$image['id'];
						$nbUpdated++;
						}
					else {
						if ($conf['updatealbum']['verbose']) $page['infos'][] = $_FILES['imagesfiles']['name'][$i].' : '.l10n('Not updated image').' -> '.$image['id'];
					}
				}
				else { // if image not found
					if ($conf['updatealbum']['create']) { // if create flag then create it
						$image['id'] = add_uploaded_file(
							$_FILES['imagesfiles']['tmp_name'][$i],
							$_FILES['imagesfiles']['name'][$i],
							array($cat_id)
							);
						if ($conf['updatealbum']['verbose']) $page['infos'][] = $_FILES['imagesfiles']['name'][$i].'  : '.l10n('Added image').' -> '.$image['id'];
						$nbCreated++;
					}
					else {
						if ($conf['updatealbum']['verbose']) $page['infos'][] = $_FILES['imagesfiles']['name'][$i].' : '.l10n('Not added image');
					}
				}
			}
		}
	$page['infos'][] = l10n('Updated images').': '.$nbUpdated.'; '.l10n('Created images').': '.$nbCreated.'; '.l10n('Error(s)').': '.$nbErrors;
	}
}


$template->assign(
  array(
    'U_JUMPTO' => make_index_url(array('category' => $category)),
	)
  );

$query = 'SELECT DISTINCT category_id
  FROM '.IMAGE_CATEGORY_TABLE.'
  WHERE category_id = '.$cat_id.'
  LIMIT 1';
$result = pwg_query($query);
$category['has_images'] = pwg_db_num_rows($result)>0 ? true : false;

// manage album elements link
if ($category['has_images'])
{
  $template->assign(
  array (
    'CAT_ID'            => $category['id'],
    'U_MANAGE_ELEMENTS' => $base_url.'batch_manager&amp;filter=album-'.$category['id']
	)
  );
}

$template->assign(array(
  'CATEGORIES_NAV' => get_cat_display_name_cache($category['uppercats'], UPDATEALBUM_ADMIN.'-album&amp;cat_id='),
));

    
// define template file
$template->set_filename('updatealbum_content', realpath(UPDATEALBUM_PATH . 'admin/template/album.tpl'));
